#include <iostream>
using namespace std;

struct pacijent{
	
	string kg;
	int brj,bro,bra,brb,brab;
	
};


int main(){
	
		ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	
	int n,o,a,b,ab;
	
	bool m1 = true, m2 = true, m3 = true, m4 = true;
	
	cin >> n;
	cin >> o >> a >> b >> ab;
	
	pacijent pacijenti[n];
	
	for(int i = 0; i < n; i++){
		
		cin >> pacijenti[i].kg >> pacijenti[i].brj;
		pacijenti[i].bro = 0;
		pacijenti[i].bra = 0;
		pacijenti[i].brb = 0;
		pacijenti[i].brab = 0;
	
	}
	
	for(int i = 0; i < n; i++){
		
		if(pacijenti[i].kg == "O" ){
			
			if (pacijenti[i].brj <= o){
			
			o -= pacijenti[i].brj;
			pacijenti[i].bro += pacijenti[i].brj;
			m1 = true;
		}
		else{
		m1 = false;
		break;	
		}
		
		
		}
		
	}
	//
	for(int i = 0; i < n; i++){
		
		if(pacijenti[i].kg == "A" ){
		
			if(pacijenti[i].brj <= a + o){
		
			
			if(pacijenti[i].brj <= a){
				a -= pacijenti[i].brj;
				pacijenti[i].bra += pacijenti[i].brj;
				
				
			}else if(pacijenti[i].brj > a){
				
					
				pacijenti[i].bra += a;
				pacijenti[i].brj -= a;
				a = 0;
				
				o -= pacijenti[i].brj;
				pacijenti[i].bro += pacijenti[i].brj;
				
			
				
			}
			m2 = true;
		}
		else{
			m2 = false;
			 break;	
		}
	
			}
	}
	//
	
	
		for(int i = 0; i < n; i++){
		
		if(pacijenti[i].kg == "B" ){
			if(pacijenti[i].brj <= b + o){
			
			if(pacijenti[i].brj <= b){
				b -= pacijenti[i].brj;
				pacijenti[i].brb += pacijenti[i].brj;
			
				
			}else if(pacijenti[i].brj > b){
				
				
				pacijenti[i].brb += b;
				pacijenti[i].brj -= b;
				b = 0;
				
				o -= pacijenti[i].brj;
				pacijenti[i].bro += pacijenti[i].brj;
				
			}
				m3 = true;
				
			}
			else{
			m3 = false;
			 break;
		}
	
			}
	}
	//
	
		for(int i = 0; i < n; i++){
		
		if(pacijenti[i].kg == "AB" ){
			
			if(pacijenti[i].brj <= o + a + b + ab){
			
					if(pacijenti[i].brj <= o){
						o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
					
					}else if(pacijenti[i].brj <= a){
						a -= pacijenti[i].brj;
						pacijenti[i].bra += pacijenti[i].brj;
					}
					 else if(pacijenti[i].brj <= b){
						b -= pacijenti[i].brj;
						pacijenti[i].brb += pacijenti[i].brj;
					}
					 else if(pacijenti[i].brj <= ab){
						ab -= pacijenti[i].brj;
						pacijenti[i].brab += pacijenti[i].brj;
					}
					else if(pacijenti[i].brj <= o + a){
						
								
						pacijenti[i].bra += a;
						pacijenti[i].brj -= a;
						a = 0;
						
						o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
						
					}
					else if(pacijenti[i].brj <= o + b){
								
						pacijenti[i].brb += b;
						pacijenti[i].brj -= b;
						b = 0;
						
						o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
						
					}
					else if(pacijenti[i].brj <= o + ab){
						
						
						pacijenti[i].brab += ab;
						pacijenti[i].brj -= ab;
						ab = 0;
						
						o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
						
					}
					else if(pacijenti[i].brj <= a + b){
						
						
						pacijenti[i].bra += a;
						pacijenti[i].brj -= a;
						a = 0;
						
						b -= pacijenti[i].brj;
						pacijenti[i].brb += pacijenti[i].brj;
						
					}
					else if(pacijenti[i].brj <= a + ab){
						
						
						pacijenti[i].bra += a;
						pacijenti[i].brj -= a;
						a = 0;
						
						ab -= pacijenti[i].brj;
						pacijenti[i].brab += pacijenti[i].brj;
						
					}
					else if(pacijenti[i].brj <= b + ab){
						
						
						pacijenti[i].brb += b;
						pacijenti[i].brj -= b;
						b = 0;
						
						ab -= pacijenti[i].brj;
						pacijenti[i].brab += pacijenti[i].brj;
						
					}
					else if(pacijenti[i].brj <= o + a + b){
						
						
						pacijenti[i].brb += b;
						pacijenti[i].brj -= b;
						b = 0;
						
						a -= pacijenti[i].brj;
						pacijenti[i].bra += pacijenti[i].brj;
						
						o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
					}
					else if(pacijenti[i].brj <= ab + a + b){
						
						
						pacijenti[i].brb += b;
						pacijenti[i].brj -= b;
						b = 0;
						
						a -= pacijenti[i].brj;
						pacijenti[i].bra += pacijenti[i].brj;
						
						ab -= pacijenti[i].brj;
						pacijenti[i].brab += pacijenti[i].brj;
					}
					else if(pacijenti[i].brj <= ab + o + b){
						
						
						pacijenti[i].brb += b;
						pacijenti[i].brj -= b;
						b = 0;
						
						o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
						
						ab -= pacijenti[i].brj;
						pacijenti[i].brab += pacijenti[i].brj;
					}
					else if(pacijenti[i].brj <= ab + o + a){
						
						
						pacijenti[i].bra += a;
						pacijenti[i].brj -= a;
						a = 0;
						
						o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
						
						ab -= pacijenti[i].brj;
						pacijenti[i].brab += pacijenti[i].brj;
					}
					
					else{
						
						
						pacijenti[i].bra += a;
						pacijenti[i].brj -= a;
						a = 0;
						
						b -= pacijenti[i].brj;
						pacijenti[i].brb += pacijenti[i].brj;
						
							o -= pacijenti[i].brj;
						pacijenti[i].bro += pacijenti[i].brj;
						
						ab -= pacijenti[i].brj;
						pacijenti[i].brab += pacijenti[i].brj;
						
					}
					
					
					
				m4 = true;
		}
			else{
			m4 = false;
			 break;
		}
	
			}
	}
	//
	

if(!m1 || !m2 || !m3 || !m4)cout << "nemoguce" << '\n';
else{
	cout << "moguce" << '\n';
	
for(int i = 0; i < n; i++){
		
		cout << pacijenti[i].bro << ' '<< pacijenti[i].bra << ' ' << pacijenti[i].brb << ' '<< pacijenti[i].brab << '\n';
	
	}
	
}
	
	return 0;
	
}